diff -r -u -H -N gcc-2.6.3/cp/parse.c gcc-i2.6.3/cp/parse.c
--- gcc-2.6.3/cp/parse.c	Fri Oct 14 14:51:23 1994
+++ gcc-i2.6.3/cp/parse.c	Tue Dec 20 16:53:24 1994
@@ -6328,277 +6270,285 @@
 		    }
 		;
     break;}
-case 487:
-#line 2769 "parse.y"
+case 485:
+#line 2765 "parse.y"
 { yyval.ttype = yyvsp[0].ttype; ;
     break;}
+case 486:
+#line 2770 "parse.y"
+{ yyval.ttype = build_parse_node (CALL_EXPR, yyval.ttype, yyvsp[-2].ttype, yyvsp[0].ttype); ;
+    break;}
+case 487:
+#line 2772 "parse.y"
+{ yyval.ttype = build_parse_node (CALL_EXPR, yyval.ttype, yyvsp[-2].ttype, yyvsp[0].ttype); ;
+    break;}
 case 488:
 #line 2774 "parse.y"
-{ yyval.ttype = build_parse_node (CALL_EXPR, yyval.ttype, yyvsp[-2].ttype, yyvsp[0].ttype); ;
+{ yyval.ttype = build_parse_node (CALL_EXPR, yyval.ttype, empty_parms (), yyvsp[0].ttype); ;
     break;}
 case 489:
 #line 2776 "parse.y"
-{ yyval.ttype = build_parse_node (CALL_EXPR, yyval.ttype, yyvsp[-2].ttype, yyvsp[0].ttype); ;
+{ yyval.ttype = build_parse_node (CALL_EXPR, yyval.ttype, NULL_TREE, NULL_TREE); ;
     break;}
 case 490:
 #line 2778 "parse.y"
-{ yyval.ttype = build_parse_node (CALL_EXPR, yyval.ttype, empty_parms (), yyvsp[0].ttype); ;
+{ yyval.ttype = build_parse_node (ARRAY_REF, yyval.ttype, yyvsp[-1].ttype); ;
     break;}
 case 491:
 #line 2780 "parse.y"
-{ yyval.ttype = build_parse_node (CALL_EXPR, yyval.ttype, NULL_TREE, NULL_TREE); ;
+{ yyval.ttype = build_parse_node (ARRAY_REF, yyval.ttype, NULL_TREE); ;
     break;}
 case 492:
 #line 2782 "parse.y"
-{ yyval.ttype = build_parse_node (ARRAY_REF, yyval.ttype, yyvsp[-1].ttype); ;
+{ yyval.ttype = yyvsp[-1].ttype; ;
     break;}
 case 493:
 #line 2784 "parse.y"
-{ yyval.ttype = build_parse_node (ARRAY_REF, yyval.ttype, NULL_TREE); ;
-    break;}
-case 494:
-#line 2786 "parse.y"
-{ yyval.ttype = yyvsp[-1].ttype; ;
-    break;}
-case 495:
-#line 2788 "parse.y"
 { push_nested_class (TREE_TYPE (yyval.ttype), 3);
 		  yyval.ttype = build_parse_node (SCOPE_REF, yyval.ttype, yyvsp[0].ttype);
 		  TREE_COMPLEXITY (yyval.ttype) = current_class_depth; ;
     break;}
-case 497:
-#line 2799 "parse.y"
+case 495:
+#line 2795 "parse.y"
 { yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); ;
     break;}
-case 498:
-#line 2801 "parse.y"
+case 496:
+#line 2797 "parse.y"
 { yyval.ttype = make_reference_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); ;
     break;}
-case 499:
-#line 2803 "parse.y"
+case 497:
+#line 2799 "parse.y"
 { yyval.ttype = make_pointer_declarator (NULL_TREE, yyvsp[0].ttype); ;
     break;}
-case 500:
-#line 2805 "parse.y"
+case 498:
+#line 2801 "parse.y"
 { yyval.ttype = make_reference_declarator (NULL_TREE, yyvsp[0].ttype); ;
     break;}
-case 501:
-#line 2807 "parse.y"
+case 499:
+#line 2803 "parse.y"
 { tree arg = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype);
 		  yyval.ttype = build_parse_node (SCOPE_REF, yyvsp[-2].ttype, arg);
 		;
     break;}
-case 503:
-#line 2815 "parse.y"
+case 501:
+#line 2811 "parse.y"
 { yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); ;
     break;}
-case 504:
-#line 2817 "parse.y"
+case 502:
+#line 2813 "parse.y"
 { yyval.ttype = make_reference_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); ;
     break;}
-case 505:
-#line 2819 "parse.y"
+case 503:
+#line 2815 "parse.y"
 { yyval.ttype = make_pointer_declarator (NULL_TREE, yyvsp[0].ttype); ;
     break;}
-case 506:
-#line 2821 "parse.y"
+case 504:
+#line 2817 "parse.y"
 { yyval.ttype = make_reference_declarator (NULL_TREE, yyvsp[0].ttype); ;
     break;}
-case 507:
-#line 2823 "parse.y"
+case 505:
+#line 2819 "parse.y"
 { tree arg = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype);
 		  yyval.ttype = build_parse_node (SCOPE_REF, yyvsp[-2].ttype, arg);
 		;
     break;}
+case 507:
+#line 2827 "parse.y"
+{ yyval.ttype = build_parse_node (CALL_EXPR, yyval.ttype, yyvsp[-2].ttype, yyvsp[0].ttype); ;
+    break;}
+case 508:
+#line 2829 "parse.y"
+{ yyval.ttype = build_parse_node (CALL_EXPR, yyval.ttype, yyvsp[-2].ttype, yyvsp[0].ttype); ;
+    break;}
 case 509:
 #line 2831 "parse.y"
-{ yyval.ttype = build_parse_node (CALL_EXPR, yyval.ttype, yyvsp[-2].ttype, yyvsp[0].ttype); ;
+{ yyval.ttype = build_parse_node (CALL_EXPR, yyval.ttype, empty_parms (), yyvsp[0].ttype); ;
     break;}
 case 510:
 #line 2833 "parse.y"
-{ yyval.ttype = build_parse_node (CALL_EXPR, yyval.ttype, yyvsp[-2].ttype, yyvsp[0].ttype); ;
+{ yyval.ttype = build_parse_node (CALL_EXPR, yyval.ttype, NULL_TREE, NULL_TREE); ;
     break;}
 case 511:
 #line 2835 "parse.y"
-{ yyval.ttype = build_parse_node (CALL_EXPR, yyval.ttype, empty_parms (), yyvsp[0].ttype); ;
+{ yyval.ttype = finish_decl_parsing (yyvsp[-1].ttype); ;
     break;}
 case 512:
 #line 2837 "parse.y"
-{ yyval.ttype = build_parse_node (CALL_EXPR, yyval.ttype, NULL_TREE, NULL_TREE); ;
+{ yyval.ttype = yyvsp[-1].ttype; ;
     break;}
 case 513:
 #line 2839 "parse.y"
-{ yyval.ttype = yyvsp[-1].ttype; ;
+{ yyval.ttype = build_parse_node (ARRAY_REF, yyval.ttype, yyvsp[-1].ttype); ;
     break;}
 case 514:
 #line 2841 "parse.y"
-{ yyval.ttype = build_parse_node (ARRAY_REF, yyval.ttype, yyvsp[-1].ttype); ;
-    break;}
-case 515:
-#line 2843 "parse.y"
 { yyval.ttype = build_parse_node (ARRAY_REF, yyval.ttype, NULL_TREE); ;
     break;}
-case 516:
-#line 2848 "parse.y"
+case 515:
+#line 2846 "parse.y"
 { got_scope = NULL_TREE;
 		  yyval.ttype = build_parse_node (SCOPE_REF, yyval.ttype, yyvsp[0].ttype); ;
     break;}
-case 517:
-#line 2854 "parse.y"
+case 516:
+#line 2852 "parse.y"
 { got_scope = NULL_TREE;
 		  yyval.ttype = build_parse_node (SCOPE_REF, yyval.ttype, yyvsp[0].ttype); ;
     break;}
-case 519:
-#line 2861 "parse.y"
+case 518:
+#line 2859 "parse.y"
 { yyval.ttype = yyvsp[0].ttype; ;
     break;}
+case 519:
+#line 2864 "parse.y"
+{ yyval.ttype = build_functional_cast (yyval.ttype, yyvsp[-1].ttype); ;
+    break;}
 case 520:
 #line 2866 "parse.y"
-{ yyval.ttype = build_functional_cast (yyval.ttype, yyvsp[-1].ttype); ;
+{ yyval.ttype = reparse_decl_as_expr (yyval.ttype, yyvsp[-1].ttype); ;
     break;}
 case 521:
 #line 2868 "parse.y"
-{ yyval.ttype = reparse_decl_as_expr (yyval.ttype, yyvsp[-1].ttype); ;
-    break;}
-case 522:
-#line 2870 "parse.y"
 { yyval.ttype = reparse_absdcl_as_expr (yyval.ttype, yyvsp[0].ttype); ;
     break;}
-case 526:
-#line 2881 "parse.y"
+case 525:
+#line 2879 "parse.y"
 { yyval.ttype = yyvsp[0].ttype; ;
     break;}
+case 526:
+#line 2886 "parse.y"
+{ got_scope = TREE_TYPE (yyval.ttype); ;
+    break;}
 case 527:
 #line 2888 "parse.y"
 { got_scope = TREE_TYPE (yyval.ttype); ;
     break;}
-case 528:
-#line 2890 "parse.y"
-{ got_scope = TREE_TYPE (yyval.ttype); ;
+case 529:
+#line 2904 "parse.y"
+{ yyval.ttype = yyvsp[0].ttype; ;
     break;}
-case 530:
-#line 2906 "parse.y"
+case 531:
+#line 2910 "parse.y"
 { yyval.ttype = yyvsp[0].ttype; ;
     break;}
 case 532:
-#line 2912 "parse.y"
-{ yyval.ttype = yyvsp[0].ttype; ;
+#line 2915 "parse.y"
+{ got_scope = NULL_TREE; ;
     break;}
 case 533:
 #line 2917 "parse.y"
-{ got_scope = NULL_TREE; ;
+{ yyval.ttype = yyvsp[-1].ttype; got_scope = NULL_TREE; ;
     break;}
 case 534:
-#line 2919 "parse.y"
-{ yyval.ttype = yyvsp[-1].ttype; got_scope = NULL_TREE; ;
+#line 2924 "parse.y"
+{ got_scope = void_type_node; ;
     break;}
 case 535:
-#line 2926 "parse.y"
-{ got_scope = void_type_node; ;
+#line 2930 "parse.y"
+{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); ;
     break;}
 case 536:
 #line 2932 "parse.y"
-{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); ;
+{ yyval.ttype = make_pointer_declarator (yyvsp[0].ttype, NULL_TREE); ;
     break;}
 case 537:
 #line 2934 "parse.y"
-{ yyval.ttype = make_pointer_declarator (yyvsp[0].ttype, NULL_TREE); ;
+{ yyval.ttype = make_reference_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); ;
     break;}
 case 538:
 #line 2936 "parse.y"
-{ yyval.ttype = make_reference_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); ;
+{ yyval.ttype = make_reference_declarator (yyvsp[0].ttype, NULL_TREE); ;
     break;}
 case 539:
 #line 2938 "parse.y"
-{ yyval.ttype = make_reference_declarator (yyvsp[0].ttype, NULL_TREE); ;
-    break;}
-case 540:
-#line 2940 "parse.y"
 { tree arg = make_pointer_declarator (yyvsp[0].ttype, NULL_TREE);
 		  yyval.ttype = build_parse_node (SCOPE_REF, yyvsp[-1].ttype, arg);
 		;
     break;}
-case 541:
-#line 2944 "parse.y"
+case 540:
+#line 2942 "parse.y"
 { tree arg = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype);
 		  yyval.ttype = build_parse_node (SCOPE_REF, yyvsp[-2].ttype, arg);
 		;
     break;}
+case 542:
+#line 2951 "parse.y"
+{ yyval.ttype = build_parse_node (ARRAY_REF, NULL_TREE, yyvsp[-1].ttype); ;
+    break;}
 case 543:
 #line 2953 "parse.y"
-{ yyval.ttype = build_parse_node (ARRAY_REF, NULL_TREE, yyvsp[-1].ttype); ;
+{ yyval.ttype = build_parse_node (ARRAY_REF, yyval.ttype, yyvsp[-1].ttype); ;
     break;}
 case 544:
-#line 2955 "parse.y"
-{ yyval.ttype = build_parse_node (ARRAY_REF, yyval.ttype, yyvsp[-1].ttype); ;
+#line 2959 "parse.y"
+{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); ;
     break;}
 case 545:
 #line 2961 "parse.y"
-{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); ;
+{ yyval.ttype = make_pointer_declarator (NULL_TREE, yyvsp[0].ttype); ;
     break;}
 case 546:
 #line 2963 "parse.y"
-{ yyval.ttype = make_pointer_declarator (NULL_TREE, yyvsp[0].ttype); ;
+{ yyval.ttype = make_pointer_declarator (yyvsp[0].ttype, NULL_TREE); ;
     break;}
 case 547:
 #line 2965 "parse.y"
-{ yyval.ttype = make_pointer_declarator (yyvsp[0].ttype, NULL_TREE); ;
+{ yyval.ttype = make_pointer_declarator (NULL_TREE, NULL_TREE); ;
     break;}
 case 548:
 #line 2967 "parse.y"
-{ yyval.ttype = make_pointer_declarator (NULL_TREE, NULL_TREE); ;
+{ yyval.ttype = make_reference_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); ;
     break;}
 case 549:
 #line 2969 "parse.y"
-{ yyval.ttype = make_reference_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); ;
+{ yyval.ttype = make_reference_declarator (NULL_TREE, yyvsp[0].ttype); ;
     break;}
 case 550:
 #line 2971 "parse.y"
-{ yyval.ttype = make_reference_declarator (NULL_TREE, yyvsp[0].ttype); ;
+{ yyval.ttype = make_reference_declarator (yyvsp[0].ttype, NULL_TREE); ;
     break;}
 case 551:
 #line 2973 "parse.y"
-{ yyval.ttype = make_reference_declarator (yyvsp[0].ttype, NULL_TREE); ;
+{ yyval.ttype = make_reference_declarator (NULL_TREE, NULL_TREE); ;
     break;}
 case 552:
 #line 2975 "parse.y"
-{ yyval.ttype = make_reference_declarator (NULL_TREE, NULL_TREE); ;
-    break;}
-case 553:
-#line 2977 "parse.y"
 { tree arg = make_pointer_declarator (yyvsp[0].ttype, NULL_TREE);
 		  yyval.ttype = build_parse_node (SCOPE_REF, yyvsp[-1].ttype, arg);
 		;
     break;}
-case 554:
-#line 2981 "parse.y"
+case 553:
+#line 2979 "parse.y"
 { tree arg = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype);
 		  yyval.ttype = build_parse_node (SCOPE_REF, yyvsp[-2].ttype, arg);
 		;
     break;}
-case 556:
-#line 2990 "parse.y"
+case 555:
+#line 2988 "parse.y"
 { yyval.ttype = yyvsp[-1].ttype; ;
     break;}
+case 557:
+#line 2992 "parse.y"
+{ yyval.ttype = build_parse_node (CALL_EXPR, yyval.ttype, yyvsp[-2].ttype, yyvsp[0].ttype); ;
+    break;}
 case 558:
 #line 2994 "parse.y"
-{ yyval.ttype = build_parse_node (CALL_EXPR, yyval.ttype, yyvsp[-2].ttype, yyvsp[0].ttype); ;
+{ yyval.ttype = build_parse_node (CALL_EXPR, yyval.ttype, empty_parms (), yyvsp[0].ttype); ;
     break;}
 case 559:
 #line 2996 "parse.y"
-{ yyval.ttype = build_parse_node (CALL_EXPR, yyval.ttype, empty_parms (), yyvsp[0].ttype); ;
+{ yyval.ttype = build_parse_node (ARRAY_REF, yyval.ttype, yyvsp[-1].ttype); ;
     break;}
 case 560:
 #line 2998 "parse.y"
-{ yyval.ttype = build_parse_node (ARRAY_REF, yyval.ttype, yyvsp[-1].ttype); ;
+{ yyval.ttype = build_parse_node (ARRAY_REF, yyval.ttype, NULL_TREE); ;
     break;}
 case 561:
 #line 3000 "parse.y"
-{ yyval.ttype = build_parse_node (ARRAY_REF, yyval.ttype, NULL_TREE); ;
+{ yyval.ttype = build_parse_node (CALL_EXPR, NULL_TREE, yyvsp[-2].ttype, yyvsp[0].ttype); ;
     break;}
 case 562:
 #line 3002 "parse.y"
-{ yyval.ttype = build_parse_node (CALL_EXPR, NULL_TREE, yyvsp[-2].ttype, yyvsp[0].ttype); ;
+{ TREE_OPERAND (yyval.ttype, 2) = yyvsp[0].ttype; ;
     break;}
 case 563:
 #line 3004 "parse.y"
@@ -6606,31 +6556,27 @@
     break;}
 case 564:
 #line 3006 "parse.y"
-{ TREE_OPERAND (yyval.ttype, 2) = yyvsp[0].ttype; ;
+{ yyval.ttype = build_parse_node (ARRAY_REF, NULL_TREE, yyvsp[-1].ttype); ;
     break;}
 case 565:
 #line 3008 "parse.y"
-{ yyval.ttype = build_parse_node (ARRAY_REF, NULL_TREE, yyvsp[-1].ttype); ;
-    break;}
-case 566:
-#line 3010 "parse.y"
 { yyval.ttype = build_parse_node (ARRAY_REF, NULL_TREE, NULL_TREE); ;
     break;}
-case 572:
-#line 3032 "parse.y"
+case 571:
+#line 3030 "parse.y"
 { emit_line_note (input_filename, lineno);
 		  pushlevel (0);
 		  clear_last_expr ();
 		  push_momentary ();
 		  expand_start_bindings (0); ;
     break;}
-case 574:
-#line 3044 "parse.y"
+case 573:
+#line 3042 "parse.y"
 { if (flag_ansi)
 		    pedwarn ("ANSI C++ forbids label declarations"); ;
     break;}
-case 577:
-#line 3055 "parse.y"
+case 576:
+#line 3053 "parse.y"
 { tree link;
 		  for (link = yyvsp[-1].ttype; link; link = TREE_CHAIN (link))
 		    {
@@ -6640,63 +6586,63 @@
 		    }
 		;
     break;}
-case 578:
-#line 3069 "parse.y"
+case 577:
+#line 3067 "parse.y"
 {;
     break;}
-case 580:
-#line 3074 "parse.y"
+case 579:
+#line 3072 "parse.y"
 { expand_end_bindings (getdecls (), kept_level_p(), 1);
 		  yyval.ttype = poplevel (kept_level_p (), 1, 0);
 		  pop_momentary (); ;
     break;}
-case 581:
-#line 3078 "parse.y"
+case 580:
+#line 3076 "parse.y"
 { expand_end_bindings (getdecls (), kept_level_p(), 1);
 		  yyval.ttype = poplevel (kept_level_p (), 1, 0);
 		  pop_momentary (); ;
     break;}
-case 582:
-#line 3082 "parse.y"
+case 581:
+#line 3080 "parse.y"
 { expand_end_bindings (getdecls (), kept_level_p(), 1);
 		  yyval.ttype = poplevel (kept_level_p (), 0, 0);
 		  pop_momentary (); ;
     break;}
-case 583:
-#line 3086 "parse.y"
+case 582:
+#line 3084 "parse.y"
 { expand_end_bindings (getdecls (), kept_level_p(), 1);
 		  yyval.ttype = poplevel (kept_level_p (), 0, 0);
 		  pop_momentary (); ;
     break;}
-case 584:
-#line 3093 "parse.y"
+case 583:
+#line 3091 "parse.y"
 { cond_stmt_keyword = "if"; ;
     break;}
-case 585:
-#line 3095 "parse.y"
+case 584:
+#line 3093 "parse.y"
 { emit_line_note (input_filename, lineno);
 		  expand_start_cond (yyvsp[0].ttype, 0); ;
     break;}
-case 587:
-#line 3102 "parse.y"
+case 586:
+#line 3100 "parse.y"
 { finish_stmt (); ;
     break;}
-case 588:
-#line 3104 "parse.y"
+case 587:
+#line 3102 "parse.y"
 { expand_end_bindings (getdecls (), kept_level_p (), 1);
 		  yyval.ttype = poplevel (kept_level_p (), 1, 0);
 		  pop_momentary (); ;
     break;}
-case 589:
-#line 3111 "parse.y"
+case 588:
+#line 3109 "parse.y"
+{ finish_stmt (); ;
+    break;}
+case 590:
+#line 3115 "parse.y"
 { finish_stmt (); ;
     break;}
 case 591:
 #line 3117 "parse.y"
-{ finish_stmt (); ;
-    break;}
-case 592:
-#line 3119 "parse.y"
 {
 		  tree expr = yyvsp[-1].ttype;
 		  emit_line_note (input_filename, lineno);
@@ -6710,82 +6656,82 @@
 		  clear_momentary ();
 		  finish_stmt (); ;
     break;}
-case 593:
-#line 3132 "parse.y"
+case 592:
+#line 3130 "parse.y"
 { expand_start_else (); ;
     break;}
-case 594:
-#line 3134 "parse.y"
+case 593:
+#line 3132 "parse.y"
 { expand_end_cond ();
 		  expand_end_bindings (getdecls (), kept_level_p (), 1);
 		  poplevel (kept_level_p (), 1, 0);
 		  pop_momentary ();
 		  finish_stmt (); ;
     break;}
-case 595:
-#line 3140 "parse.y"
+case 594:
+#line 3138 "parse.y"
 { expand_end_cond ();
 		  expand_end_bindings (getdecls (), kept_level_p (), 1);
 		  poplevel (kept_level_p (), 1, 0);
 		  pop_momentary ();
 		  finish_stmt (); ;
     break;}
-case 596:
-#line 3146 "parse.y"
+case 595:
+#line 3144 "parse.y"
 { emit_nop ();
 		  emit_line_note (input_filename, lineno);
 		  expand_start_loop (1);
 		  cond_stmt_keyword = "while"; ;
     break;}
+case 596:
+#line 3149 "parse.y"
+{ expand_exit_loop_if_false (0, yyvsp[0].ttype); ;
+    break;}
 case 597:
 #line 3151 "parse.y"
-{ expand_exit_loop_if_false (0, yyvsp[0].ttype); ;
-    break;}
-case 598:
-#line 3153 "parse.y"
 { expand_end_bindings (getdecls (), kept_level_p (), 1);
 		  poplevel (kept_level_p (), 1, 0);
 		  pop_momentary ();
 		  expand_end_loop ();
 		  finish_stmt (); ;
     break;}
-case 599:
-#line 3159 "parse.y"
+case 598:
+#line 3157 "parse.y"
 { emit_nop ();
 		  emit_line_note (input_filename, lineno);
 		  expand_start_loop_continue_elsewhere (1); ;
     break;}
-case 600:
-#line 3163 "parse.y"
+case 599:
+#line 3161 "parse.y"
 { expand_loop_continue_here ();
 		  cond_stmt_keyword = "do"; ;
     break;}
-case 601:
-#line 3166 "parse.y"
+case 600:
+#line 3164 "parse.y"
 { emit_line_note (input_filename, lineno);
 		  expand_exit_loop_if_false (0, yyvsp[-1].ttype);
 		  expand_end_loop ();
 		  clear_momentary ();
 		  finish_stmt (); ;
     break;}
-case 602:
-#line 3172 "parse.y"
+case 601:
+#line 3170 "parse.y"
 { emit_nop ();
 		  emit_line_note (input_filename, lineno);
 		  if (yyvsp[0].ttype) cplus_expand_expr_stmt (yyvsp[0].ttype);
 		  expand_start_loop_continue_elsewhere (1); ;
     break;}
-case 603:
-#line 3177 "parse.y"
+case 602:
+#line 3175 "parse.y"
 { emit_line_note (input_filename, lineno);
 		  if (yyvsp[-1].ttype) expand_exit_loop_if_false (0, yyvsp[-1].ttype); ;
     break;}
-case 604:
-#line 3182 "parse.y"
+case 603:
+#line 3180 "parse.y"
 { push_momentary (); ;
     break;}
-case 605:
-#line 3184 "parse.y"
+case 604:
+#line 3182 "parse.y"
 { emit_line_note (input_filename, lineno);
 		  expand_end_bindings (getdecls (), kept_level_p (), 1);
 		  poplevel (kept_level_p (), 1, 0);
@@ -6796,24 +6742,24 @@
 		  expand_end_loop ();
 		  finish_stmt (); ;
     break;}
-case 606:
-#line 3194 "parse.y"
+case 605:
+#line 3192 "parse.y"
 { emit_nop ();
 		  emit_line_note (input_filename, lineno);
 		  expand_start_loop_continue_elsewhere (1); ;
     break;}
-case 607:
-#line 3198 "parse.y"
+case 606:
+#line 3196 "parse.y"
 { emit_line_note (input_filename, lineno);
 		  if (yyvsp[-1].ttype) expand_exit_loop_if_false (0, yyvsp[-1].ttype); ;
     break;}
-case 608:
-#line 3203 "parse.y"
+case 607:
+#line 3201 "parse.y"
 { push_momentary ();
 		  yyvsp[0].itype = lineno; ;
     break;}
-case 609:
-#line 3206 "parse.y"
+case 608:
+#line 3204 "parse.y"
 { emit_line_note (input_filename, (int) yyvsp[-2].itype);
 		  expand_end_bindings (getdecls (), kept_level_p (), 1);
 		  poplevel (kept_level_p (), 1, 0);
@@ -6825,16 +6771,16 @@
 		  finish_stmt ();
 		;
     break;}
-case 610:
-#line 3217 "parse.y"
+case 609:
+#line 3215 "parse.y"
 { emit_line_note (input_filename, lineno);
 		  c_expand_start_case (yyvsp[-1].ttype);
 		  /* Don't let the tree nodes for $4 be discarded by
 		     clear_momentary during the parsing of the next stmt.  */
 		  push_momentary (); ;
     break;}
-case 611:
-#line 3223 "parse.y"
+case 610:
+#line 3221 "parse.y"
 { expand_end_case (yyvsp[-3].ttype);
 		  pop_momentary ();
 		  expand_end_bindings (getdecls (), kept_level_p (), 1);
@@ -6842,8 +6788,8 @@
 		  pop_momentary ();
 		  finish_stmt (); ;
     break;}
-case 612:
-#line 3230 "parse.y"
+case 611:
+#line 3228 "parse.y"
 { register tree value = check_cp_case_value (yyvsp[-1].ttype);
 		  register tree label
 		    = build_decl (LABEL_DECL, NULL_TREE, NULL_TREE);
@@ -6868,8 +6814,8 @@
 		  define_case_label (label);
 		;
     break;}
-case 614:
-#line 3255 "parse.y"
+case 613:
+#line 3253 "parse.y"
 { register tree value1 = check_cp_case_value (yyvsp[-3].ttype);
 		  register tree value2 = check_cp_case_value (yyvsp[-1].ttype);
 		  register tree label
@@ -6901,8 +6847,8 @@
 		  define_case_label (label);
 		;
     break;}
-case 616:
-#line 3287 "parse.y"
+case 615:
+#line 3285 "parse.y"
 {
 		  tree duplicate;
 		  register tree label
@@ -6918,40 +6864,40 @@
 		  define_case_label (NULL_TREE);
 		;
     break;}
-case 618:
-#line 3303 "parse.y"
+case 617:
+#line 3301 "parse.y"
 { emit_line_note (input_filename, lineno);
 		  if ( ! expand_exit_something ())
 		    error ("break statement not within loop or switch"); ;
     break;}
-case 619:
-#line 3307 "parse.y"
+case 618:
+#line 3305 "parse.y"
 { emit_line_note (input_filename, lineno);
 		  if (! expand_continue_loop (0))
 		    error ("continue statement not within a loop"); ;
     break;}
-case 620:
-#line 3311 "parse.y"
+case 619:
+#line 3309 "parse.y"
 { emit_line_note (input_filename, lineno);
 		  c_expand_return (NULL_TREE); ;
     break;}
-case 621:
-#line 3314 "parse.y"
+case 620:
+#line 3312 "parse.y"
 { emit_line_note (input_filename, lineno);
 		  c_expand_return (yyvsp[-1].ttype);
 		  finish_stmt ();
 		;
     break;}
-case 622:
-#line 3319 "parse.y"
+case 621:
+#line 3317 "parse.y"
 { if (TREE_CHAIN (yyvsp[-2].ttype)) yyvsp[-2].ttype = combine_strings (yyvsp[-2].ttype);
 		  emit_line_note (input_filename, lineno);
 		  expand_asm (yyvsp[-2].ttype);
 		  finish_stmt ();
 		;
     break;}
-case 623:
-#line 3326 "parse.y"
+case 622:
+#line 3324 "parse.y"
 { if (TREE_CHAIN (yyvsp[-4].ttype)) yyvsp[-4].ttype = combine_strings (yyvsp[-4].ttype);
 		  emit_line_note (input_filename, lineno);
 		  c_expand_asm_operands (yyvsp[-4].ttype, yyvsp[-2].ttype, NULL_TREE, NULL_TREE,
@@ -6960,8 +6906,8 @@
 		  finish_stmt ();
 		;
     break;}
-case 624:
-#line 3335 "parse.y"
+case 623:
+#line 3333 "parse.y"
 { if (TREE_CHAIN (yyvsp[-6].ttype)) yyvsp[-6].ttype = combine_strings (yyvsp[-6].ttype);
 		  emit_line_note (input_filename, lineno);
 		  c_expand_asm_operands (yyvsp[-6].ttype, yyvsp[-4].ttype, yyvsp[-2].ttype, NULL_TREE,
@@ -6970,8 +6916,8 @@
 		  finish_stmt ();
 		;
     break;}
-case 625:
-#line 3345 "parse.y"
+case 624:
+#line 3343 "parse.y"
 { if (TREE_CHAIN (yyvsp[-8].ttype)) yyvsp[-8].ttype = combine_strings (yyvsp[-8].ttype);
 		  emit_line_note (input_filename, lineno);
 		  c_expand_asm_operands (yyvsp[-8].ttype, yyvsp[-6].ttype, yyvsp[-4].ttype, yyvsp[-2].ttype,
@@ -6980,83 +6926,83 @@
 		  finish_stmt ();
 		;
     break;}
-case 626:
-#line 3353 "parse.y"
+case 625:
+#line 3351 "parse.y"
 { emit_line_note (input_filename, lineno);
 		  expand_computed_goto (yyvsp[-1].ttype); ;
     break;}
-case 627:
-#line 3356 "parse.y"
+case 626:
+#line 3354 "parse.y"
 { tree decl;
 		  emit_line_note (input_filename, lineno);
 		  decl = lookup_label (yyvsp[-1].ttype);
 		  TREE_USED (decl) = 1;
 		  expand_goto (decl); ;
     break;}
-case 628:
-#line 3362 "parse.y"
+case 627:
+#line 3360 "parse.y"
 { finish_stmt (); ;
     break;}
-case 629:
-#line 3364 "parse.y"
+case 628:
+#line 3362 "parse.y"
 { error ("label must be followed by statement");
 		  yyungetc ('}', 0);
 		  finish_stmt (); ;
     break;}
-case 630:
-#line 3368 "parse.y"
+case 629:
+#line 3366 "parse.y"
 { finish_stmt (); ;
     break;}
-case 632:
-#line 3374 "parse.y"
+case 631:
+#line 3372 "parse.y"
 { expand_start_try_stmts (); ;
     break;}
-case 633:
-#line 3376 "parse.y"
+case 632:
+#line 3374 "parse.y"
 { expand_end_try_stmts ();
 		  expand_start_all_catch (); ;
     break;}
-case 634:
-#line 3379 "parse.y"
+case 633:
+#line 3377 "parse.y"
 { expand_end_all_catch (); ;
     break;}
-case 635:
-#line 3387 "parse.y"
+case 634:
+#line 3385 "parse.y"
 { expand_end_bindings (0,1,1);
 		  poplevel (2,0,0);
 		;
     break;}
-case 636:
-#line 3391 "parse.y"
+case 635:
+#line 3389 "parse.y"
 { expand_end_bindings (0,1,1);
 		  poplevel (2,0,0);
 		;
     break;}
-case 637:
-#line 3395 "parse.y"
+case 636:
+#line 3393 "parse.y"
 { expand_end_bindings (0,1,1);
 		  poplevel (2,0,0);
 		;
     break;}
-case 639:
-#line 3403 "parse.y"
+case 638:
+#line 3401 "parse.y"
 { emit_line_note (input_filename, lineno); ;
     break;}
-case 640:
-#line 3405 "parse.y"
+case 639:
+#line 3403 "parse.y"
 { expand_end_catch_block (); ;
     break;}
-case 643:
-#line 3415 "parse.y"
+case 642:
+#line 3413 "parse.y"
 { expand_start_catch_block (NULL_TREE, NULL_TREE); ;
     break;}
-case 644:
-#line 3427 "parse.y"
+case 643:
+#line 3425 "parse.y"
 { expand_start_catch_block (TREE_PURPOSE (yyvsp[-1].ttype),
 					    TREE_VALUE (yyvsp[-1].ttype)); ;
     break;}
-case 645:
-#line 3433 "parse.y"
+case 644:
+#line 3431 "parse.y"
 { tree label;
 		do_label:
 		  label = define_label (input_filename, lineno, yyvsp[-1].ttype);
@@ -7064,25 +7010,29 @@
 		    expand_label (label);
 		;
     break;}
+case 645:
+#line 3438 "parse.y"
+{ goto do_label; ;
+    break;}
 case 646:
 #line 3440 "parse.y"
 { goto do_label; ;
     break;}
 case 647:
-#line 3442 "parse.y"
-{ goto do_label; ;
+#line 3445 "parse.y"
+{ yyval.ttype = NULL_TREE; ;
     break;}
 case 648:
 #line 3447 "parse.y"
-{ yyval.ttype = NULL_TREE; ;
+{ yyval.ttype = yyvsp[-1].ttype; ;
     break;}
 case 649:
 #line 3449 "parse.y"
-{ yyval.ttype = yyvsp[-1].ttype; ;
+{ yyval.ttype = NULL_TREE; ;
     break;}
 case 650:
-#line 3451 "parse.y"
-{ yyval.ttype = NULL_TREE; ;
+#line 3454 "parse.y"
+{ yyval.itype = 0; ;
     break;}
 case 651:
 #line 3456 "parse.y"
@@ -7090,55 +7040,51 @@
     break;}
 case 652:
 #line 3458 "parse.y"
-{ yyval.itype = 0; ;
+{ yyval.itype = 1; ;
     break;}
 case 653:
 #line 3460 "parse.y"
-{ yyval.itype = 1; ;
-    break;}
-case 654:
-#line 3462 "parse.y"
 { yyval.itype = -1; ;
     break;}
-case 655:
-#line 3469 "parse.y"
+case 654:
+#line 3467 "parse.y"
 { emit_line_note (input_filename, lineno);
 		  yyval.ttype = NULL_TREE; ;
     break;}
-case 656:
-#line 3472 "parse.y"
+case 655:
+#line 3470 "parse.y"
 { emit_line_note (input_filename, lineno); ;
     break;}
-case 657:
-#line 3477 "parse.y"
+case 656:
+#line 3475 "parse.y"
 { yyval.ttype = NULL_TREE; ;
     break;}
-case 659:
-#line 3480 "parse.y"
+case 658:
+#line 3478 "parse.y"
 { yyval.ttype = NULL_TREE; ;
     break;}
-case 660:
-#line 3486 "parse.y"
+case 659:
+#line 3484 "parse.y"
 { yyval.ttype = NULL_TREE; ;
     break;}
-case 663:
-#line 3493 "parse.y"
+case 662:
+#line 3491 "parse.y"
 { yyval.ttype = chainon (yyval.ttype, yyvsp[0].ttype); ;
     break;}
-case 664:
-#line 3498 "parse.y"
+case 663:
+#line 3496 "parse.y"
 { yyval.ttype = build_tree_list (yyval.ttype, yyvsp[-1].ttype); ;
     break;}
-case 665:
-#line 3503 "parse.y"
+case 664:
+#line 3501 "parse.y"
 { yyval.ttype = tree_cons (NULL_TREE, yyval.ttype, NULL_TREE); ;
     break;}
-case 666:
-#line 3505 "parse.y"
+case 665:
+#line 3503 "parse.y"
 { yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyval.ttype); ;
     break;}
-case 667:
-#line 3515 "parse.y"
+case 666:
+#line 3513 "parse.y"
 {
 		  if (strict_prototype)
 		    yyval.ttype = void_list_node;
@@ -7146,39 +7092,39 @@
 		    yyval.ttype = NULL_TREE;
 		;
     break;}
-case 669:
-#line 3523 "parse.y"
+case 668:
+#line 3521 "parse.y"
 { yyval.ttype = tree_cons (NULL_TREE, yyval.ttype, void_list_node);
 		  TREE_PARMLIST (yyval.ttype) = 1; ;
     break;}
-case 670:
-#line 3531 "parse.y"
+case 669:
+#line 3529 "parse.y"
 {
 		  yyval.ttype = chainon (yyval.ttype, void_list_node);
 		  TREE_PARMLIST (yyval.ttype) = 1;
 		;
     break;}
-case 671:
-#line 3536 "parse.y"
+case 670:
+#line 3534 "parse.y"
 {
 		  TREE_PARMLIST (yyval.ttype) = 1;
 		;
     break;}
-case 672:
-#line 3541 "parse.y"
+case 671:
+#line 3539 "parse.y"
 {
 		  TREE_PARMLIST (yyval.ttype) = 1;
 		;
     break;}
-case 673:
-#line 3545 "parse.y"
+case 672:
+#line 3543 "parse.y"
 {
 		  yyval.ttype = build_tree_list (NULL_TREE, yyval.ttype); 
 		  TREE_PARMLIST (yyval.ttype) = 1;
 		;
     break;}
-case 674:
-#line 3550 "parse.y"
+case 673:
+#line 3548 "parse.y"
 {
 		  /* ARM $8.2.5 has this as a boxed-off comment.  */
 		  if (pedantic)
@@ -7186,27 +7132,27 @@
 		  yyval.ttype = NULL_TREE;
 		;
     break;}
-case 675:
-#line 3557 "parse.y"
+case 674:
+#line 3555 "parse.y"
 {
 		  TREE_PARMLIST (yyval.ttype) = 1;
 		;
     break;}
-case 676:
-#line 3561 "parse.y"
+case 675:
+#line 3559 "parse.y"
 {
 		  TREE_PARMLIST (yyval.ttype) = 1;
 		;
     break;}
-case 677:
-#line 3565 "parse.y"
+case 676:
+#line 3563 "parse.y"
 {
 		  yyval.ttype = build_tree_list (NULL_TREE, yyval.ttype);
 		  TREE_PARMLIST (yyval.ttype) = 1;
 		;
     break;}
-case 678:
-#line 3570 "parse.y"
+case 677:
+#line 3568 "parse.y"
 {
 		  /* This helps us recover from really nasty
 		     parse errors, for example, a missing right
@@ -7218,8 +7164,8 @@
 		  yychar = ')';
 		;
     break;}
-case 679:
-#line 3581 "parse.y"
+case 678:
+#line 3579 "parse.y"
 {
 		  /* This helps us recover from really nasty
 		     parse errors, for example, a missing right
